<?
/*
 Network Interface Statistics Collection Agent v2.5
 by Brett Baugh

 This saves your changes to the "interfaces" table in the database.
 */

if ($count=="" || $host=="" || $method=="") {
  header("Location: adm_hosts1.php");
  die;
}

require_once("/etc/nisca/nisca.conf");
require_once($location["security"]);
error_reporting(0);

if ($dynamo != "") { $d = "y"; } else { $d = ""; }

// Build the array of all communities used on this host.
if (! $communes=preg_split('/\s*,\s*/', $comms)) {
  $communes=array();
  $communes[0]=$comms;
} else {
  $cout=array();
  foreach ($communes as $c) {
    if (trim($c) != "") {
      $cout[]=$c;
    }
  }
  $communes=$cout;
}

// Get the needed OIDS for this host.
$nums=array();
$oid=set_oids();
$v2capable="y";
foreach ($communes as $ctmp) {
  $ifentries=mysnmpwalkoid($host, $ctmp, $oid["ifEntry"], $v2capable, TRUE);
//  if (!isset($ifentries[$oid["ifIndex"]])) {
  if (count(oid_suck($ifentries, $oid["ifIndex"])) < 1) {
// This means this host cannot do snmpv2c. Have to do it the slow, non-bulk way.
    $v2capable="";
    $ifentries=mysnmpwalkoid($host, $ctmp, $oid["ifEntry"], $v2capable, TRUE); 
  }
// If the $method is in $odd_oids, we'll need it too.
  if (in_array($method, $odd_oids)) {
    $tmp2=mysnmpwalkoid($host, $ctmp, $oid[$method], $v2capable, TRUE);
    $ifentries=array_merge($ifentries, $tmp2);
  }
// And we'll need the ifXEntry tree if $method isn't in $ifentries by this point.
  if (!in_array($method, $oid)) {
    $tmp2=mysnmpwalkoid($host, $ctmp, $oid["ifXEntry"], $v2capable, TRUE);
    $ifentries=array_merge($ifentries, $tmp2);
  }
  $ifentries=result_fix($ifentries);
  $ifspeeds[$ctmp]=oid_suck($ifentries, $oid["Speed"]);
  $a=oid_suck($ifentries, $oid[$method]);
  for(reset($a); $k=key($a); next($a)) {
    $if_num=preg_replace('/^.+\.(\d+)$/', '\\1', $k);
    $nums[$ctmp][$name]=$if_num;
  }
}

$sqarray=array();
$snmp_msgs="";
$on_count=0;
for ($i=0; $i < $count; $i++) {
  $tmp="do$i";
  $t1=$$tmp;
  if ($t1 != "") {
    $tmp="v2_$i";
    $v=$$tmp;
    $tmp="alias$i";
    $alias=$$tmp;
    $tmp="cir$i";
    $cir=$$tmp;
    if (trim($cir)=="") { $cir=0; }
    $cir=preg_replace('/\D/', '', $cir);
    $tmp="speed$i";
    $speed=$$tmp;
    if (trim($speed)=="") { $speed=0; }
    $speed=preg_replace('/\D/', '', $speed);
    list($c, $if) = preg_split('/!/', $t1);
    if ($c=="") { $c="public"; }
    if ($speed=="") {
      $speed=$ifspeeds[$c][$oid["Speed"].".".$nums[$c][$if]];
      if ($speed=="") {
        $speed=0;
      }
    }
    if ($speed=="") {
      $speed=0;
    }
    $on_count++;
    $sqarray[]="insert into interfaces values('$host', '$if', '$c', '$d', '$v', '$alias', $speed, '$hostalias', '$method', $cir)";
// If there was a method change, update the stats_ifs table so nothing gets lost.
    $tmp="oldifname$i";
    if (trim($$tmp) != "") {
      $oname=$$tmp;
      $sqarray[]="update stats_ifs set if_name='$if' where hostname='$host' AND if_name='$oname' AND community='$c'";
    }
  }
}

$sq="delete from interfaces where hostname='$host'";
$res=dosql($sq);

if ($on_count==0) {
  $snmp_msgs="This isn't precisely an error, but you left all the interfaces unselected. " .
    "This is just like deleting \"$host\", which has just been done (leaving its stats " .
    "untouched).<BR>\n$snmp_msgs";
} else {
  foreach ($sqarray as $sq) {
    $res=dosql($sq);
  }
}
if ($snmp_msgs == "") {
  header("Location: adm_hosts1.php?msg=success");
  die;
}
?>
<html><head>
<title>Network Interface Statistics Collection Agent - SNMP Interface Administration 2</title>
<style type="text/css">
* { font-family: <? echo $fontface; ?>; }
</style>
</head>
<? echo default_body() . titlebar("SNMP Host Administration"); ?>
<hr noshade size=1>
<P>The changes to the host &quot;<? echo $host; ?>&quot; were successful, <B>but</B>...</P>
<P>
<? print_error($snmp_msgs); ?>
</P>
<hr noshade size=1>
<P>
<a href="<? echo $location["admin"]; ?>/adm_hosts1.php">Host Administration Menu</a><BR>
<a href="<? echo $location["admin"]; ?>/">Main Administration Menu</a>
</P>
</body></html>
